package runEnv;

import env.*;
 
public class MethodTableValue extends RunValue {
	private DeclList methodTable;

	public MethodTableValue( DeclList methodTable ) {
		if ( methodTable == null )
			throw new Error( "Null method table" );
		this.methodTable = methodTable;
		}

	public DeclList methodTable() {
		return methodTable;
		}

	public String toString() {
		return "methodTable";
		}

	public boolean equals( RunValue otherValue ) {
		if ( ! ( otherValue instanceof MethodTableValue ) )
			return false;
		MethodTableValue otherMethod = ( MethodTableValue ) otherValue;
		return otherMethod.methodTable() == methodTable;
		}
	}
