package runEnv.basicValue;

import runEnv.*;
 
public class IntValue extends BasicValue {

	public final static IntValue defaultValue = new IntValue( 0 );

	private int value;

	public IntValue( int value ) {
		this.value = value;
		}

	public int intValue() {
		return value;
		}

	public double floatValue() {
		return ( double ) value;
		}

	public char charValue() {
		return ( char ) value;
		}

	public String toString() {
		return "" + value;
		}

	public String stringValue() {
		return "" + value;
		}

	public boolean equals( RunValue otherValue ) {
		return otherValue.intValue() == value;
		}
	}
