package node.exprNode.postfixNode;

import node.exprNode.*;

public class OptSeqNode extends PostfixNode {

	public OptSeqNode( ExprNode left ) {
		super( left );
		operator = "*";
		}
		
	public boolean match( String s ) {
		if ( s.length() == 0 )
			return true;
		else {
			for ( int i = 1; i < s.length() + 1; i++ )
				if ( left.match( s.substring( 0, i ) ) && match( s.substring( i ) ) )
					return true;
			return false;
			}
		}
		
	}

