package node.exprNode.postfixNode;

import node.exprNode.*;

public class SeqNode extends PostfixNode {

	public SeqNode( ExprNode left ) {
		super( left );
		operator = "+";
		}
		
	public boolean match( String s ) {
		if ( left.match( s ) )
			return true;
		else {
			for ( int i = 1; i < s.length(); i++ )
				if ( left.match( s.substring( 0, i ) ) && match( s.substring( i ) ) )
					return true;
			return false;
			}
		}
		
	}
