package node.stmtNode;

import runEnv.*;
import node.exprNode.*;
import text.*;

public class AssignStmtNode extends StmtNode {

	private String ident;
	private ExprNode expr;

	public AssignStmtNode( String ident, ExprNode expr ) {
		this.ident = ident;
		this.expr = expr;
		}

	public String toString() {
		return ident + " = " + expr +";";
		}

	public void eval( RunEnv runEnv ) {
		Object value = expr.eval( runEnv );
		runEnv.put( ident, Cast.intValue( value ) );
		Print.interp().println( ident + " = " + value );
		}
	}
