package node.exprNode;

import runEnv.*;
import node.*;

public abstract class ExprNode extends Node {

	protected final static int PREC_OR		=	1;
	protected final static int PREC_AND		=	2;
	protected final static int PREC_REL		=	3;
	protected final static int PREC_ADD		=	4;
	protected final static int PREC_MUL		=	5;
	protected final static int PREC_PREFIX	=	6;
	protected final static int PREC_PRIMARY	=	7;

	protected int precedence;

	public abstract Object eval( RunEnv runEnv );

	public String toString( int parentPrec ) {
		if ( precedence < parentPrec )
			return "( " + toString() + " )";
		else
			return toString();
		}

	}
