package node.stmtNode;

import runEnv.*;
import node.*;
import text.*;

public class StmtListNode extends ListNode< StmtNode > {

	public StmtListNode() {
		super( "%n" );
		}
	
	public StmtListNode( StmtNode node ) {
		this();
		addElement( node );
		}
		
	public void eval( RunEnv runEnv ) {
		for ( int i = 0; i < size(); i++ ) {
			StmtNode stmt = elementAt( i );
			try {
				stmt.eval( runEnv );
				}
			catch ( Error exception ) {
				Print.error().println( "Runtime Error " + exception.getMessage() );
				}
			catch ( RuntimeException exception ) {
				Print.error().println( "Runtime Exception " + exception.getMessage() );
				}
			}
		}
		
	}

