package node.declNode.declaratorNode;
import runEnv.*;
import java.util.*;

public class SimpleDeclaratorNode extends DeclaratorNode {

	private String ident;

	public SimpleDeclaratorNode( String ident ) {
		this.ident = ident;
		}

	public String toString() {
		return ident;
		}

	public void eval( Hashtable< String, Object > localDecls, RunEnv runEnv ) {
		if ( localDecls.get( ident ) != null )
			error( ident + " redeclared" );
		localDecls.put( ident, new NullValue() );
		}
	}
