package node.exprNode;
import runEnv.*;
import node.exprNode.variableNode.*;

public class VarExprNode extends ExprNode {

	private VariableNode variable;
	
	public VarExprNode( VariableNode variable ) {
		this.variable = variable;
		precedence = PREC_PRIMARY;
		}

	public Object eval( RunEnv runEnv ) {
		return variable.eval( runEnv ).get();
		}

	public String toString() {
		return "" + variable;
		}
	}
