package node.exprNode.primaryNode;
import runEnv.*;
import node.exprNode.*;

import java.util.*;

public class NewArrayNode extends PrimaryNode {

	private ExprNode sizeExpr;

	public NewArrayNode( ExprNode sizeExpr ) {
		this.sizeExpr = sizeExpr;
		}

	public Object eval( RunEnv runEnv ) {
		int size = Cast.intValue( sizeExpr.eval( runEnv ) );
		Vector< Object > array = new Vector< Object >();
		for ( int i = 0; i < size; i++ )
			array.addElement( new NullValue() );
		return array;
		}
		
	public String toString() {
		return "new[ " + sizeExpr + " ]";
		}
	}
