package node.exprNode.primaryNode;
import runEnv.*;
import node.exprNode.*;

import java.util.*;

public class OrdNode extends PrimaryNode {

	private ExprNode expr;
	
	public OrdNode( ExprNode expr ) {
		this.expr = expr;
		}
		
	public String toString() {
		return "ord( " + expr + " )";
		}
		
	public Object eval( RunEnv runEnv ) {
		return new Integer( ( int ) Cast.charValue( expr.eval( runEnv ) ) );
		}

	}
