package node.stmtNode;

import runEnv.*;
import node.exprNode.*;

public class DoStmtNode extends StmtNode {

	private StmtListNode stmtList;
	private ExprNode cond;

	public DoStmtNode( StmtListNode stmtList, ExprNode cond ) {
		this.stmtList = stmtList;
		this.cond = cond;
		}

	public String toString() {
		return "do%+%n" + stmtList + "%-%nend%nwhile " + cond + ";";
		}

	public void eval( RunEnv runEnv ) throws ReturnException {
		do
			stmtList.eval( runEnv );
		while ( Cast.booleanValue( cond.eval( runEnv ) ) );
		}
		
	}
