package node.stmtNode;

import runEnv.*;
import node.exprNode.*;

public class ExprStmtNode extends StmtNode {

	private ExprNode expr;
	
	public ExprStmtNode( ExprNode expr ) {
		this.expr = expr;
		}
		
	public String toString() {
		return expr + ";";
		}
		
	public void eval( RunEnv runEnv ) {
		expr.eval( runEnv );
		}

	}
