package node.stmtNode;

import runEnv.*;
import node.*;

public class StmtListNode extends ListNode< StmtNode > {

	public StmtListNode() {
		super( "%n" );
		}
	
	public StmtListNode( StmtNode node ) {
		this();
		addElement( node );
		}
		
	public void eval( RunEnv runEnv ) throws ReturnException {
		for ( int i = 0; i < size(); i++ ) {
			StmtNode stmt = elementAt( i );
			stmt.eval( runEnv );
			}
		}
		
	}
