package runEnv;

import java.util.*;

public class IdentVariableValue extends VariableValue {

	private Hashtable< String, Object > locals;
	private String ident;
	
	public IdentVariableValue( Hashtable< String, Object > locals, String ident ) {
		this.locals = locals;
		this.ident = ident;
		}

	public Object get() {
		return locals.get( ident );
		}

	public void set( Object value ) {
		locals.put( ident, value );
		}

	public String toString() {
		return ident;
		}
	}
