package node.exprNode.binaryNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import node.exprNode.*;

public abstract class BinaryNode extends ExprNode {

	protected String operator;
	protected ExprNode left, right;

	public BinaryNode( ExprNode left, ExprNode right ) {
		this.left = left;
		this.right = right;
		}
		
	public String toString() {
		return 
			left.toString( precedence ) 
			+ " " +  operator + " " 
			+ right.toString( precedence + 1 );
		}

	}
