package node.exprNode.prefixNode;
import env.*;
import type.*;
import runEnv.*;
import node.exprNode.*;

public abstract class PrefixNode extends ExprNode {

	protected String operator;
	protected ExprNode right;

	public PrefixNode( ExprNode right ) {
		this.right = right;
		precedence = PREC_PREFIX;
		}
		
	public String toString() {
		return operator + " " + right.toString( precedence );
		}

	}
