package node.exprNode.valueNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class BoolValueNode extends ValueNode {

	private Boolean value;

	public BoolValueNode( Boolean value ) {
		this.value = value;
		}

	public String toString() {
		return "" + value;
		}

	public Type checkType( Env env ) {
		type = BoolType.type;
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		return new RunValue( value.booleanValue() );
		}
	}
