package node.exprNode.valueNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import text.*;

public class CharValueNode extends ValueNode {

	private Character value;

	public CharValueNode( Character value ) {
		this.value = value;
		}

	public String toString() {
		return "\'" + Convert.toString( value.charValue() )+ "\'";
		}

	public Type checkType( Env env ) {
		type = CharType.type;
		return type;
		}
		
		
	public RunValue eval( RunEnv runEnv ) {
		return new RunValue( value.charValue() );
		}
	}
