package node.stmtNode;
import env.*;
import type.*;
import runEnv.*;
import node.exprNode.*;

public class ElseOpt1Node extends ElseOptNode {

	private StmtListNode elsePart;

	public ElseOpt1Node( StmtListNode elsePart ) {
		this.elsePart = elsePart;
		}

	public String toString() {
		return "%nelse%+%n" + elsePart + "%-";
		}

	public void checkType( Env env ) {
		elsePart.checkType( env );
		}
		
	public void eval( RunEnv runEnv ) throws ReturnException {
		elsePart.eval( runEnv );
		}

	}
