package node.stmtNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import node.exprNode.*;

public class ExprStmtNode extends StmtNode {

	private ExprNode expr;
	
	public ExprStmtNode( ExprNode expr ) {
		this.expr = expr;
		}
		
	public String toString() {
		return expr + ";";
		}
		
	public void checkType( Env env ) {
		Type type = expr.checkType( env );
		expr = expr.castTo( VoidType.type );
		}

	public void eval( RunEnv runEnv ) {
		expr.eval( runEnv );
		}

	}
