package node.exprNode.binaryNode.boolNode;
import node.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;

public class AndNode extends BoolNode {

	public AndNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_AND;
		operator = "&&";
		}

	public RunValue eval( RunEnv runEnv ) {
		RunValue leftValue = left.eval( runEnv );
		RunValue rightValue = right.eval( runEnv );
		return new BoolValue( leftValue.boolValue() && rightValue.boolValue() );
		}

	}
