package node.exprNode.primaryNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;

public class NullExprNode extends PrimaryNode {

	public NullExprNode() {
		}
		
	public String toString() {
		return "";
		}
		
	public Type checkType() {
		type = BoolType.type;
		return type;
		}

	public RunValue eval( RunEnv runEnv ) {
		return new BoolValue( true );
		}

	}
