package node.exprNode.valueNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import text.*;
import runEnv.*;
import runEnv.basicValue.*;

public class CharValueNode extends ValueNode {

	private Character value;

	public CharValueNode( Character value ) {
		this.value = value;
		}

	public String toString() {
		return "\'" + Convert.toString( value.charValue() )+ "\'";
		}

	public Type checkType() {
		type = CharType.type;
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		return new CharValue( value.charValue() );
		}

	}
