package node.exprNode.variableNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import runEnv.*;

public abstract class VariableNode extends Node {
	protected Type type;
	public Type type() { return type; }
	protected boolean addressable = true;
	public boolean addressable() { return addressable; }
	
	public abstract Type checkType();

	public abstract RunAddress evalAddress( RunEnv runEnv );

	public RunValue evalValue( RunEnv runEnv ) {
		return evalAddress( runEnv ).getValue();
		}

	}
