package node.stmtNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class ExprListStmtNode extends StmtNode {

	private ExprListNode exprList;
	
	public ExprListStmtNode( ExprListNode exprList ) {
		this.exprList = exprList;
		}
		
	public String toString() {
		return "" + exprList + ";";
		}
		
	public void genEnv( Env env ) {
		super.genEnv( env );
		exprList.genEnv( env );
		}

	public void setType() {
		}

	public void checkType() {
		exprList.checkType();
		}

	public void eval( RunEnv runEnv ) {
		exprList.evalVoid( runEnv );
		}

	}
