package type.basicType;

import type.*;
import runEnv.*;
import runEnv.basicValue.*;

public  class IntType extends BasicType {

	public final static IntType type = new IntType();

	public IntType() {
		}

	public boolean equals( Type type ) {
		if ( type == null )
			throw new Error( "Trying to compare null type with " + this );
		if ( type == this )
			return true;
		return type instanceof IntType;
		}

	public String toString() {
		return "int";
		}
		
	public RunValue defaultValue() {
		return new IntValue( 0 );
		}

	}
