package node.exprNode.valueNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;

public class IntValueNode extends ValueNode {

	private Integer value;

	public IntValueNode( Integer value ) {
		this.value = value;
		}

	public String toString() {
		return "" + value;
		}

	public Type checkType() {
		type = IntType.type;
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		return new IntValue( value.intValue() );
		}

	public void regCode( int freeReg, int freeTemp ) {
		loadIQ( tempReg( freeReg ), literal( value.intValue() ) );
		}
	}
