package runEnv.basicValue;

import runEnv.*;

public class StringValue extends ArrayValue {

	public StringValue( Multiple array ) {
		super( array );
		}

	public StringValue( String value ) {
		super( new Multiple( value.length() ) );
		for ( int i = 0; i < value.length(); i++ )
			array().setValue( i, new CharValue( value.charAt( i ) ) );
		}

	public String stringValue() {
		return toString();
		}

	public String toString() {
		String result = "";
		for ( int i = 0; i < array().size(); i++ )
			result += array().getValue( i );
		return result;
		}

	public ArrayValue subArray( int low, int high ) {
		return new StringValue( array().subMultiple( low, high ) );
		}

	}
