package type.basicType;

import type.*;
import runEnv.*;
import runEnv.basicValue.*;

public  class CharType extends BasicType {

	public final static CharType type = new CharType();

	public CharType() {
		}

	public boolean equals( Type type ) {
		return type instanceof CharType;
		}

	public String toString() {
		return "char";
		}
		
	public boolean isCastable( Type type ) {
		return type instanceof IntType || type instanceof CharType;
		}

	public RunValue defaultValue() {
		return new CharValue( '\0' );
		}

	}
