package type.basicType;

import type.*;
import runEnv.*;
import runEnv.basicValue.*;

public  class IntType extends BasicType {

	public final static IntType type = new IntType();

	public IntType() {
		}

	public boolean equals( Type type ) {
		return type instanceof IntType;
		}

	public String toString() {
		return "int";
		}
		
	public boolean isCastable( Type type ) {
		return type instanceof IntType || type instanceof CharType;
		}

	public RunValue defaultValue() {
		return new IntValue( 0 );
		}

	}
