package type.basicType;

import type.*;
import runEnv.*;
import runEnv.basicValue.*;

public  class RealType extends BasicType {

	public final static RealType type = new RealType();

	public RealType() {
		}

	public boolean equals( Type type ) {
		return type instanceof RealType;
		}

	public boolean isCastable( Type type ) {
		return type instanceof RealType || type instanceof IntType || type instanceof CharType;
		}

	public String toString() {
		return "real";
		}
		
	public RunValue defaultValue() {
		return new RealValue( 0.0 );
		}

	}
