package node.exprNode;

public class ProcInvocNode extends ExprNode {

	IdentNode ident;
	ExprListNode params;

	public ProcInvocNode( IdentNode ident, ExprListNode params ) {
		precedence = PREC_PRIMARY;
		this.ident = ident;
		this.params = params;
		}

	public String toString() {
		if ( params.size() == 0 )
			return ident.toString() + "()";
		else
			return ident.toString() + "( " + params.toString() + " )";
		}
	}
