package grammar;

import java.io.*;

%%

%{
	boolean printed = false;
	
	void echo( String text ) {
		System.out.print( text );
		printed = true;
		}
%}

%public
%type Void

newline		=	\r|\n|\r\n
%%
"/*"~"*/"		{ }
"{:"~":}"		{ }
{newline}		{
				if ( printed ) {
				    System.out.println();
				    printed = false;
				    }
				}
:[A-Za-z0-9]+	{ }
.				{ echo( yytext() ); }
