package node;
import env.*;
import runEnv.*;

public abstract class DeclStmtNode extends Node {
	private int section;
	public int section() { return section; }
	public void genEnv( int section, Env env ) {
		super.genEnv( env );
		this.section = section;
		}
	public abstract void setType();
	public abstract void checkType();
	
	public abstract void genOffset();
	public abstract void eval( RunEnv runEnv ) throws ReturnException;

	public abstract void genCode();
	}
