package node.exprNode.binaryNode.arithNode;
import node.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public abstract class ArithNode extends BinaryNode {

	public ArithNode( ExprNode left, ExprNode right ) {
		super( left, right );
		}

	public Type checkType() {
		Type leftType = left.checkType();
		Type rightType = right.checkType();
		operandType = IntType.type;
		left = left.castTo( Type.CAST_IMPLICIT, operandType );
		right = right.castTo( Type.CAST_IMPLICIT, operandType );
		type = operandType;
		return type;
		}

	}
