package node.exprNode.valueNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import code.*;
import runEnv.*;
import runEnv.basicValue.*;

public class NullValueNode extends ValueNode {

	public NullValueNode() {
		}

	public String toString() {
		return "null";
		}

	public Type checkType() {
		type = NullType.type;
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		return NullValue.defaultValue;
		}

	public void evalCode( Node sibling ) {
		setSibling( sibling );
		setAddress( new Literal( 0 ) );
		}
	}
