package node.stmtNode.elseOptNode;
import node.*;
import node.stmtNode.*;
import node.exprNode.*;
import env.*;
import type.*;
import runEnv.*;

public class ElseOpt1Node extends ElseOptNode {

	private DeclStmtListNode elsePart;

	public ElseOpt1Node( DeclStmtListNode elsePart ) {
		this.elsePart = elsePart;
		}

	public String toString() {
		return "%nelse%+%n" + elsePart + "%-";
		}

	public void genEnv( int section, Env env ) {
		super.genEnv( section, env );
		elsePart.genEnv( section, env );
		}

	public void checkType() {
		elsePart.checkType();
		}
		
	public void eval( RunEnv runEnv ) throws ReturnException {
		elsePart.eval( runEnv );
		}

	public void genCode() {
		elsePart.genCode();
		}
	}
