package runEnv.basicValue;

import runEnv.*;

public class FloatValue extends BasicValue {

	public final static FloatValue defaultValue = new FloatValue( 0.0 );

	private double value;

	public FloatValue( double value ) {
		this.value = value;
		}

	public double floatValue() {
		return value;
		}

	public String toString() {
		return "" + value;
		}

	public boolean equals( RunValue otherValue ) {
		return otherValue.floatValue() == value;
		}
	}
