package runEnv.basicValue;

import runEnv.*;

public class NullValue extends BasicValue {

	public final static NullValue defaultValue = new NullValue();
	
	public NullValue() {
		}

	public String toString() {
		return "null";
		}

	public String stringValue() {
		return "null";
		}

	public PtrValue addressValue() {
		return null;
		}

	public boolean equals( RunValue otherValue ) {
		return otherValue instanceof NullValue;
		}
	}
