package type.basicType;

import type.*;
import env.*;
import runEnv.*;
import runEnv.basicValue.*;

public  class CharType extends BasicType {

	public final static CharType type = new CharType();

	public CharType() {
		}

	public boolean equals( Type type ) {
		return type instanceof CharType;
		}

	public String toString() {
		return "char";
		}
		
	public boolean isCastable( int castKind, Type type ) {
		return type instanceof IntType || type instanceof CharType;
		}

	public Offset size() {
		return new Offset( 1, 1 );
		}
		
	public void initAddress( RunEnv runEnv, PtrValue address ) {
		address.setValue( CharValue.defaultValue );
		}

	}
