package node.exprNode;

import node.*;

public abstract class ExprNode extends Node {

	protected final static int PREC_OR		=	1;
	protected final static int PREC_CONCAT	=	2;
	protected final static int PREC_POSTFIX	=	3;
	protected final static int PREC_SIMPLE	=	4;

	protected int precedence;

	public String toString( int parentPrec ) {
		if ( precedence < parentPrec )
			return "(" + toString() + ")";
		else
			return toString();
		}

	public abstract boolean match( String s );
		
	}
