package node.exprNode.binaryNode;

import node.exprNode.*;

public class OrNode extends BinaryNode {

	public OrNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_OR;
		operator = "|";
		}
		
	public boolean match( String s ) {
		return left.match( s ) || right.match( s );
		}
		
	}