package node.exprNode.binaryNode;

import runEnv.*;
import node.exprNode.*;

public class DivideNode extends BinaryNode {

	public DivideNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_MUL;
		operator = "/";
		}

	public int eval( RunEnv runEnv ) {
		int leftValue = left.eval( runEnv );
		int rightValue = right.eval( runEnv );
		return leftValue / rightValue;
		}
		
	}
