package node.exprNode.binaryNode;

import runEnv.*;
import node.exprNode.*;

public class TimesNode extends BinaryNode {

	public TimesNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_MUL;
		operator = "*";
		}

	public int eval( RunEnv runEnv ) {
		int leftValue = left.eval( runEnv );
		int rightValue = right.eval( runEnv );
		return leftValue * rightValue;
		}
		
	}
