package node.exprNode;

import runEnv.*;
import node.*;

public abstract class ExprNode extends Node {

	protected final static int PREC_ASSIGN	=	0;
	protected final static int PREC_REL		=	1;
	protected final static int PREC_ADD		=	2;
	protected final static int PREC_MUL		=	3;
	protected final static int PREC_PREFIX	=	4;
	protected final static int PREC_PRIMARY	=	5;

	protected int precedence;

	public String toString( int parentPrec ) {
		if ( precedence < parentPrec )
			return "( " + toString() + " )";
		else
			return toString();
		}

	public abstract Object eval( RunEnv runEnv );

	}
