package node.stmtNode;

import runEnv.*;
import node.exprNode.*;

public class IfThenStmtNode extends StmtNode {

	private ExprNode cond;
	private StmtNode stmt;

	public IfThenStmtNode( ExprNode cond, StmtNode stmt ) {
		this.cond = cond;
		this.stmt = stmt;
		}

	public String toString() {
		return "if " + cond + " then%+%n" + stmt + "%-";
		}

	public void eval( RunEnv runEnv ) {
		if ( Cast.booleanValue( cond.eval( runEnv ) ) )
			stmt.eval( runEnv );
		}
		
	}
