package node.exprNode.prefixNode;

import runEnv.*;
import node.exprNode.*;

public class NotNode extends PrefixNode {

	public NotNode( ExprNode right ) {
		super( right );
		operator = "not";
		}

	public Object eval( RunEnv runEnv ) {
		boolean rightValue = Cast.booleanValue( right.eval( runEnv ) );
		return new Boolean( ! rightValue );
		}
		
	}
