package node.stmtNode;

import runEnv.*;
import text.*;
import node.exprNode.*;

public class PrintStmtNode extends StmtNode {

	private ExprNode expr;
	
	public PrintStmtNode( ExprNode expr ) {
		this.expr = expr;
		}
		
	public String toString() {
		return "print( " + expr + " );";
		}
		
	public void eval( RunEnv runEnv ) {
		Print.interp().print( expr.eval( runEnv ) );
		}

	}
