package node.stmtNode;

import runEnv.*;
import text.*;
import node.exprNode.*;

public class Println1StmtNode extends StmtNode {

	private ExprNode expr;
	
	public Println1StmtNode( ExprNode expr ) {
		this.expr = expr;
		}
		
	public String toString() {
		return "println( " + expr + " );";
		}
		
	public void eval( RunEnv runEnv ) {
		Print.interp().println( expr.eval( runEnv ) );
		}

	}
