package runEnv;

import java.util.*;

public class SubscriptVariableValue extends VariableValue {

	private Vector< Object > array;
	private int subscript;
	
	public SubscriptVariableValue( Vector< Object > array, int subscript ) {
		this.array = array;
		this.subscript = subscript;
		}

	public Object get() {
		return array.elementAt( subscript );
		}

	public void set( Object value ) {
		array.setElementAt( value, subscript );
		}

	}
