package node.declNode;
import env.*;
import runEnv.*;
import node.*;
import text.*;
import java.util.*;

public class DeclListNode extends ListNode< DeclNode > {

	public DeclListNode() {
		super( "%n" );
		}
	
	public DeclListNode( DeclNode node ) {
		this();
		addElement( node );
		}
		
	public void checkType( Block localBlock, Env env ) {
		for ( int i = 0; i < size(); i++ ) {
			try {
				DeclNode decl = elementAt( i );
				decl.checkType( localBlock, env );
				}
			catch ( Error exception ) {
				Print.error().println( exception.getMessage() );
				setElementAt( i, new ErrorDeclNode() );
				}
			}
		}

	}

