package node.typeNode;
import env.*;
import type.*;
import runEnv.*;
import node.declNode.*;

public class StructTypeNode extends TypeNode {

	private DeclListNode fields;

	public StructTypeNode( DeclListNode fields ) {
		this.fields = fields;
		}

	public String toString() {
		return "struct(%+" + fields + "%n%-)";
		}

	public Type getType( Env env ) {
		Block localBlock = new Block();
		fields.checkType( localBlock, env );
		localBlock.setAddress( 0 );
		return new StructType( localBlock );
		}
		
	}
