package type;

import env.*;

public  class RefType extends Type {

	private Decl decl;

	public Decl decl() { return decl; }

	public RefType( Decl decl ) {
		this.decl = decl;
		}

	public Type nonRefType() {
		return decl.type().nonRefType();
		}

	// This is WRONG!!!!!!!!!!!
	// May go into infinite recursion with equivalent, 
	// but separately declared recursive types
	public boolean equals( Type type ) {
		if ( type == null )
			return false;
		type = type.nonRefType();
		return decl().type().equals( type );
		}

	public String toString() {
		return "ref " + decl.ident();
		}
		
	}
