package type.basicType;

import type.*;

public  class NullType extends BasicType {

	public final static NullType type = new NullType();

	public NullType() {
		}

	public boolean equals( Type type ) {
		if ( type == null )
			return false;
		type = type.nonRefType();
		if ( this == type )
			return true;
		return type instanceof NullType;
		}

	public String toString() {
		return "null";
		}
		
	}
