package type.basicType;

import type.*;

public  class VoidType extends BasicType {

	public final static VoidType type = new VoidType();

	public VoidType() {
		}

	public boolean equals( Type type ) {
		if ( type == null )
			return false;
		type = type.nonRefType();
		if ( this == type )
			return true;
		return type instanceof VoidType;
		}

	public String toString() {
		return "void";
		}
		
	}
