package node.exprNode.prefixNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;

public class NotNode extends PrefixNode {

	public NotNode( ExprNode right ) {
		super( right );
		operator = "!";
		}

	public Type checkType() {
		Type rightType = right.checkType();
		operandType = BoolType.type;
		type = BoolType.type;
		right = right.castTo( type );
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		RunValue rightValue = right.eval( runEnv );
		return new BoolValue( ! rightValue.boolValue() );
		}

	}
