package node.exprNode.valueNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import text.*;
import runEnv.*;
import runEnv.basicValue.*;

public class StringValueNode extends ValueNode {

	private String value;

	public StringValueNode( String value ) {
		this.value = value;
		}

	public String toString() {
		return "\"" + Convert.toString( value ) + "\"";
		}

	public Type checkType() {
		type = StringType.type;
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		return new StringValue( value );
		}

	}
