package type.basicType;

import type.*;
import runEnv.*;
import runEnv.basicValue.*;

public  class CharType extends BasicType {

	public final static CharType type = new CharType();

	public CharType() {
		}

	public boolean equals( Type type ) {
		if ( type == null )
			throw new Error( "Trying to compare null type with " + this );
		if ( type == this )
			return true;
		return type instanceof CharType;
		}

	public String toString() {
		return "char";
		}
		
	public RunValue defaultValue() {
		return new CharValue( '\0' );
		}

	}
