package node.exprNode.postfixNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public abstract class PostfixNode extends ExprNode {

	protected String operator;
	protected Type operandType;
	protected ExprNode left;

	public PostfixNode( ExprNode left ) {
		this.left = left;
		precedence = PREC_POSTFIX;
		}
		
	public String toString() {
		return  left.toString( precedence ) + " " + operator;
		}

	public void genEnv( Env env ) {
		left.genEnv( env );
		}

	}
