package node.stmtNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import runEnv.*;

public abstract class StmtNode extends DeclStmtNode {

	public void genEnv( int section, Env env ) {
		genEnv( env );
		}

	public abstract void genEnv( Env env );

	public void genDecl() {
		// Assume there are no local declarations
		}

	public void genDeclCode() {
		}
	}
