package node.exprNode.binaryNode;

import node.exprNode.*;

public class BinaryNode extends ExprNode {

	String operator;
	ExprNode left, right;

	public BinaryNode( ExprNode left, ExprNode right ) {
		this.left = left;
		this.right = right;
		}

	public String toString() {
		return 
			left.toString( precedence ) 
			+ " " +  operator + " " 
			+ right.toString( precedence + 1 );
		}
	}
