package node.exprNode.postfixNode;

import node.exprNode.*;

public class PostfixNode extends ExprNode {

	String operator;
	ExprNode left;

	public PostfixNode( ExprNode left ) {
		this.left = left;
		precedence = PREC_POSTFIX;
		}

	public String toString() {
		return 
			left.toString( precedence ) 
			+ " " +  operator;
		}
	}
