package node.exprNode.prefixNode;

import node.exprNode.*;

public class PrefixNode extends ExprNode {

	String operator;
	ExprNode right;

	public PrefixNode( ExprNode right ) {
		this.right = right;
		precedence = PREC_PREFIX;
		}

	public String toString() {
		return 
			operator + " " 
			+ right.toString( precedence );
		}
	}
